/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.access.client;

import com.google.gwt.user.client.Element;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.widget.core.client.Component;

/**
 * Adds a frame around a given widget to indicate a widget has focus.
 */
public class FocusFrame {
  private static FocusFrame instance;

  public static FocusFrame get() {
    if (instance == null) {
      instance = new FocusFrame();
    }
    return instance;
  }

  private boolean initialized;
  private Component curComponent;
  // private Element curElement;
  private XElement focusFrameContainer;

  // private List<XElement> sides = new ArrayList<XElement>();

  private FocusFrame() {

  }

  /**
   * Frames the given widget.
   * 
   * @param newComponent the widget to be framed
   */
  public void frame(Component newComponent) {
    frame(newComponent, null);
  }

  /**
   * Frames the given widget.
   * 
   * @param newComponent the widget to be framed
   * @param newElement a child element of the widget where the frame should
   *          be applied
   */
  public void frame(Component newComponent, Element newElement) {
    if (!FocusManager.get().isEnabled()) {
      return;
    }

    if (!initialized) {
      init();
    }

    if (curComponent != newComponent) {
      // if (newComponent.isRendered()) {
      // curComponent = newComponent;
      // curElement = newElement != null ? newElement :
      // curComponent.getElement();
      // XElement e = El.fly(curElement);
      // e.getParent().makePositionable();
      // e.getParent().dom.appendChild(focusFrameContainer.dom);
      // focusFrameContainer.show();
      // sync(curComponent, newElement);
      // }
    }

  }

  /**
   * Hides the frame.
   * 
   * @param c the framed widget
   */
  public void hide(Component c) {
    if (initialized && c == curComponent) {
      focusFrameContainer.setVisible(false);
    }
  }

  /**
   * Shows the frame on a widget that has been previously framed.
   * 
   * @param c the widget
   */
  public void show(Component c) {
    if (initialized && c == curComponent) {
      focusFrameContainer.setVisible(true);
      sync(c);
    }
  }

  /**
   * Updates the frame's size and position to match the widget.
   * 
   * @param c the widget
   */
  public void sync(Component c) {
    sync(c, null);
  }

  /**
   * Updates the frame's size and position to match the widget's child
   * element.
   * 
   * @param c the widget
   * @param elem the child element
   */
  public void sync(Component c, Element elem) {
    // if (initialized && curComponent == c && c.isRendered()) {
    // El el = elem != null ? new El(elem) : curComponent.el();
    // int width = el.getWidth();
    // int height = el.getHeight();
    //
    // sides.get(0).setSize(width, 2).alignTo(el.dom, "tl", null);
    // sides.get(1).setSize(width, 2).alignTo(el.dom, "bl", new int[] {0, -2});
    // sides.get(2).setSize(2, height).alignTo(el.dom, "tr", new int[] {-2, 0});
    // sides.get(3).setSize(2, height).alignTo(el.dom, "tl", null);
    //
    // for (El side : sides) {
    // side.setZIndex(curComponent.el().getZIndex() + 1);
    // }
    // }
  }

  /**
   * Removes and visible frames.
   */
  public void unframe() {
    if (initialized) {
      focusFrameContainer.hide();
      curComponent = null;
      // curElement = null;
    }
  }

  /**
   * Remove the comonent's frame.
   * 
   * @param c the widget
   */
  public void unframe(Component c) {
    if (c == curComponent) {
      unframe();
    }
  }

  protected void init() {
    // if (!initialized) {
    // focusFrameContainer = new El(DOM.createDiv());
    // focusFrameContainer.setStyleName("x-aria-focusframe");
    // focusFrameContainer.makePositionable();
    // focusFrameContainer.hide();
    //
    // for (int i = 0; i < 4; i++) {
    // El side = new El(DOM.createDiv());
    // side.setStyleName("x-aria-focusframe-side");
    // focusFrameContainer.dom.appendChild(side.dom);
    // side.makePositionable(true);
    // sides.add(side);
    // }
    // initialized = true;
    // }
  }
}
