/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.access.client;

import java.util.List;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.widget.core.client.Component;

/**
 * Navigation handlers are responsible for specifying the child widgets of a
 * container. In addition, the handler determines the order in which the
 * children are navigated.
 */
public interface NavigationHandler {

  /**
   * Determines if the this handler instance can handle the given widget.
   * 
   * @param comp the target widget
   * @return the list of ordered child widgets of the container
   */
  public boolean canHandleTabKey(Component comp);

  /**
   * Returns the list of ordered widgets.
   * 
   * @param widget the target widget
   * @return the list of ordered widgets
   */
  public List<Widget> getOrderedWidgets(Widget widget);

}
