/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.core.client;

/**
 * A <code>ValueProvider</code> implementation that simply call {@link #toString()} on the target model.
 *
 * @param <T> the model type
 */
public class ToStringValueProvider<T> implements ValueProvider<T, String> {

  private String path;
  
  public ToStringValueProvider(String path) {
    this.path = path;
  }
  
  @Override
  public String getValue(T object) {
    return object.toString();
  }

  @Override
  public void setValue(T object, String value) {

  }

  @Override
  public String getPath() {
    return path;
  }

}
