/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.core.client.resources;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.StyleInjector;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.CssResource;
import com.google.gwt.resources.client.ImageResource;

public class CommonStyles {

  public interface Styles extends CssResource {

    @ClassName("x-clear")
    String clear();

    String columnResize();

    String columnRowResize();

    String disabled();

    String floatRight();

    String hideDisplay();

    String hideOffsets();

    String hideVisibility();

    String ignore();

    String inlineBlock();

    String nodrag();

    String nowrap();

    String positionable();

    String repaint();

    String shim();

    String unselectable();

    String unselectableSingle();

  }

  static interface Bundle extends ClientBundle {

    ImageResource shim();

    @Source("CommonStyles.css")
    Styles styles();

  }

  private static Bundle instance = GWT.create(Bundle.class);

  private static boolean injected;

  public static Styles get() {
    if (!injected) {
      StyleInjector.inject(instance.styles().getText(), true);
      injected = true;
    }
    return instance.styles();
  }

}
