/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.data.shared;

import com.google.gwt.editor.client.Editor.Path;
import com.sencha.gxt.core.client.ValueProvider;

/**
 * Interface implemented by types that provide access to properties of bean-like
 * models. Methods can be of type {@link ValueProvider} or
 * {@link ModelKeyProvider}, but in both cases, the type T should match the
 * generic type for PropertyAccess{@literal @}T>, as that will be the type that
 * will be used with them.
 * 
 * Method names should map to existing model properties, except for the get- and
 * set- prefix that is used to change those properties. Much as with the GWT
 * Editor functionality, nested properties or properties with names un-related
 * to their method may also be defined using the {@link Path} annotation.
 * 
 * @param <T> the target type
 */
public interface PropertyAccess<T> {

}
