/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.theme.base.client.grid;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.CssResource;
import com.google.gwt.resources.client.CssResource.NotStrict;
import com.google.gwt.resources.client.ImageResource;
import com.google.gwt.resources.client.ImageResource.ImageOptions;
import com.google.gwt.resources.client.ImageResource.RepeatStyle;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.core.client.resources.StyleInjectorHelper;
import com.sencha.gxt.widget.core.client.grid.Grid.GridAppearance;

public class GridBaseAppearance implements GridAppearance {

  public interface GridResources extends ClientBundle {
    @Source("Grid.css")
    @NotStrict
    GridStyle css();
    
    @ImageOptions(repeatStyle = RepeatStyle.Horizontal)
    ImageResource columnHeader();
    
    @ImageOptions(repeatStyle = RepeatStyle.Horizontal)
    ImageResource columnHeaderOver();
    
    @ImageOptions(repeatStyle = RepeatStyle.Both, preventInlining = true)
    ImageResource columnHeaderBtn();
    
    ImageResource sortAscendingIcon();
    
    ImageResource sortDescendingIcon();
    
    ImageResource columnsIcon();
  }

  public interface GridStyle extends CssResource {

  }
  
  private final GridResources resources;
  private final GridStyle style;
  
  public GridBaseAppearance() {
    this(GWT.<GridResources>create(GridResources.class));
  }
  
  public GridBaseAppearance(GridResources resources) {
    this.resources = resources;
    this.style = this.resources.css();
    
    StyleInjectorHelper.ensureInjected(style, true);
  }

  @Override
  public void render(SafeHtmlBuilder sb) {
    sb.appendHtmlConstant("<div></div>");
  }

  @Override
  public ImageResource sortAcendingIcon() {
    return resources.sortAscendingIcon();
  }

  @Override
  public ImageResource sortDescendingIcon() {
    return resources.sortDescendingIcon();
  }

  @Override
  public ImageResource columnsIcon() {
    return resources.columnsIcon();
  }

}
