/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Cursor;
import com.sencha.gxt.fx.client.Draggable;
import com.sencha.gxt.theme.base.client.panel.FramedPanelAppearance;

public class Portlet extends FramedPanel {

  private boolean pinned = false;
  
  public Portlet() {
    this(GWT.<FramedPanelAppearance>create(FramedPanelAppearance.class));
  }
  
  public Portlet(FramedPanelAppearance appearance) {
    super(appearance);
    setPinned(false);
  }

  /**
   * Returns true if the portal is pinned.
   * 
   * @return true if pinned
   */
  public boolean isPinned() {
    return pinned;
  }

  public void setPinned(boolean pinned) {
    this.pinned = pinned;
    Cursor c = pinned ? Cursor.DEFAULT : Cursor.MOVE;
    getHeader().getElement().getStyle().setCursor(c);

    if (getData("gxt.draggable") != null) {
      Draggable d = (Draggable) getData("gxt.draggable");
      d.setEnabled(!pinned);
    }
  }
}
