/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.button;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.uibinder.client.UiConstructor;
import com.sencha.gxt.widget.core.client.button.Tools.ToolStyle;

/**
 * A {@link IconButton} that supports a set of predefined styles, see
 * {@link IconButton.IconConfig}.
 */
public class ToolButton extends IconButton {

  private static ToolStyle style = GWT.<Tools>create(Tools.class).icons();

  public static IconConfig CLOSE = new IconConfig(style.close(), style.closeOver());
  public static IconConfig COLLAPSE = new IconConfig(style.collapse(), style.collapseOver());
  public static IconConfig DOUBLEDOWN = new IconConfig(style.doubleDown(), style.doubleDownOver());
  public static IconConfig DOUBLELEFT = new IconConfig(style.doubleLeft(), style.doubleLeftOver());
  public static IconConfig DOUBLERIGHT = new IconConfig(style.doubleRight(), style.doubleRightOver());
  public static IconConfig DOUBLEUP = new IconConfig(style.doubleUp(), style.doubleUpOver());
  public static IconConfig DOWN = new IconConfig(style.down(), style.downOver());
  public static IconConfig EXPAND = new IconConfig(style.expand(), style.expand());
  public static IconConfig GEAR = new IconConfig(style.gear(), style.gearOver());
  public static IconConfig LEFT = new IconConfig(style.left(), style.leftOver());
  public static IconConfig MAXIMIZE = new IconConfig(style.maximize(), style.maximizeOver());
  public static IconConfig MINIMIZE = new IconConfig(style.minimize(), style.minimizeOver());
  public static IconConfig MINUS = new IconConfig(style.minus(), style.minusOver());
  public static IconConfig PIN = new IconConfig(style.pin(), style.pinOver());
  public static IconConfig UNPIN = new IconConfig(style.unpin(), style.unpinOver());
  public static IconConfig PLUS = new IconConfig(style.plus(), style.plusOver());
  public static IconConfig PRINT = new IconConfig(style.print(), style.printOver());
  public static IconConfig QUESTION = new IconConfig(style.question(), style.questionOver());
  public static IconConfig REFRESH = new IconConfig(style.refresh(), style.refreshOver());
  public static IconConfig RESTORE = new IconConfig(style.restore(), style.restoreOver());
  public static IconConfig RIGHT = new IconConfig(style.right(), style.rightOver());
  public static IconConfig SAVE = new IconConfig(style.save(), style.saveOver());
  public static IconConfig SEARCH = new IconConfig(style.search(), style.searchOver());
  public static IconConfig UP = new IconConfig(style.up(), style.upOver());

  public ToolButton(IconButtonAppearance appearance, IconConfig config) {
    super(appearance, config);
  }

  @UiConstructor
  public ToolButton(IconConfig config) {
    super(config);
  }

  public ToolButton(IconConfig config, ClickHandler handler) {
    super(config);
    addClickHandler(handler);
  }

  public ToolButton(String style) {
    this(new IconConfig(style));
  }

}
