/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.grid;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.sencha.gxt.widget.core.client.grid.LiveGridViewUpdateEvent.LiveGridViewUpdateHandler;

public final class LiveGridViewUpdateEvent extends GwtEvent<LiveGridViewUpdateHandler> {
  public interface LiveGridViewUpdateHandler extends EventHandler {
    void onUpdate(LiveGridViewUpdateEvent event);
  }

  private static GwtEvent.Type<LiveGridViewUpdateHandler> TYPE;

  public static GwtEvent.Type<LiveGridViewUpdateHandler> getType() {
    if (TYPE == null) {
      TYPE = new GwtEvent.Type<LiveGridViewUpdateHandler>();
    }
    return TYPE;
  }

  private final int liveStoreOffset;

  private final int rowCount;

  private final int totalCount;

  private final int viewIndex;

  public LiveGridViewUpdateEvent(int liveStoreOffset, int viewIndex, int totalCount, int rowCount) {
    this.liveStoreOffset = liveStoreOffset;
    this.viewIndex = viewIndex;
    this.totalCount = totalCount;
    this.rowCount = rowCount;
  }

  @Override
  public GwtEvent.Type<LiveGridViewUpdateHandler> getAssociatedType() {
    return TYPE;
  }

  public int getLiveStoreOffset() {
    return liveStoreOffset;
  }

  public int getRowCount() {
    return rowCount;
  }

  public int getTotalCount() {
    return totalCount;
  }

  public int getViewIndex() {
    return viewIndex;
  }

  @Override
  protected void dispatch(LiveGridViewUpdateHandler handler) {
    handler.onUpdate(this);

  }
}
