/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.grid.editing;

import com.sencha.gxt.data.shared.Converter;
import com.sencha.gxt.widget.core.client.event.BeforeStartEditEvent.HasBeforeStartEditHandlers;
import com.sencha.gxt.widget.core.client.event.CancelEditEvent.HasCancelEditHandlers;
import com.sencha.gxt.widget.core.client.event.CompleteEditEvent.HasCompleteEditHandlers;
import com.sencha.gxt.widget.core.client.event.StartEditEvent.HasStartEditHandlers;
import com.sencha.gxt.widget.core.client.form.Field;
import com.sencha.gxt.widget.core.client.grid.ColumnConfig;
import com.sencha.gxt.widget.core.client.grid.Grid;
import com.sencha.gxt.widget.core.client.grid.Grid.GridCell;

public interface GridEditing<M> extends HasBeforeStartEditHandlers<M>, HasStartEditHandlers<M>,
    HasCompleteEditHandlers<M>, HasCancelEditHandlers<M> {
  <N, O> void addEditor(ColumnConfig<M, N> columnConfig, Converter<N, O> converter, Field<O> field);

  <N> void addEditor(ColumnConfig<M, N> columnConfig, Field<N> field);

  void cancelEditing();

  void completeEditing();

  <N, O> Converter<N, O> getConverter(ColumnConfig<M, N> columnConfig);

  Grid<M> getEditableGrid();

  <O> Field<O> getEditor(ColumnConfig<M, ?> columnConfig);

  boolean isEditing();

  void removeEditor(ColumnConfig<M, ?> columnConfig);

  void setEditableGrid(Grid<M> editableGrid);

  void startEditing(GridCell cell);
}
